Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Botan::CurveGFp_Repr Class Referenceabstract

`#include <curve_gfp.h>`

## Public Member Functions
virtual bool | a_is_minus_3 () const =0
virtual bool | a_is_zero () const =0
void | curve_mul (BigInt &z, const BigInt &x, const BigInt &y, secure_vector< word > &ws) const
virtual void | curve_mul_words (BigInt &z, const word x_words[], const size_t x_size, const BigInt &y, secure_vector< word > &ws) const =0
void | curve_sqr (BigInt &z, const BigInt &x, secure_vector< word > &ws) const
virtual void | curve_sqr_words (BigInt &z, const word x_words[], size_t x_size, secure_vector< word > &ws) const =0
virtual void | from_curve_rep (BigInt &x, secure_vector< word > &ws) const =0
virtual const BigInt & | get_1_rep () const =0
virtual const BigInt & | get_a () const =0
virtual const BigInt & | get_a_rep () const =0
virtual const BigInt & | get_b () const =0
virtual const BigInt & | get_b_rep () const =0
virtual const BigInt & | get_p () const =0
virtual size_t | get_p_words () const =0
virtual size_t | get_ws_size () const =0
virtual BigInt | invert_element (const BigInt &x, secure_vector< word > &ws) const =0
virtual bool | is_one (const BigInt &x) const =0
virtual void | to_curve_rep (BigInt &x, secure_vector< word > &ws) const =0
virtual | ~CurveGFp_Repr ()=default

## Detailed Description

Definition at line 21 of file curve_gfp.h.

## Constructor & Destructor Documentation

virtual Botan::CurveGFp_Repr::~CurveGFp_Repr | ( |  | ) |
| virtual default

## Member Function Documentation

virtual bool Botan::CurveGFp_Repr::a_is_minus_3 | ( |  | ) | const
| pure virtual

virtual bool Botan::CurveGFp_Repr::a_is_zero | ( |  | ) | const
| pure virtual

void Botan::CurveGFp_Repr::curve_mul | ( | BigInt & | z,
|  | const BigInt & | x,
|  | const BigInt & | y,
|  | secure_vector< word > & | ws
| ) |  | const
| inline

Definition at line 61 of file curve_gfp.h.

References BOTAN_DEBUG_ASSERT, Botan::BigInt::data(), Botan::BigInt::sig_words(), and Botan::BigInt::size().

63 {
64 BOTAN_DEBUG_ASSERT(x.sig_words() <= get_p_words());
65 curve_mul_words(z, x.data(), x.size(), y, ws);
66 }
BOTAN_DEBUG_ASSERT
#define BOTAN_DEBUG_ASSERT(expr)
Definition: assert.h:123
Botan::CurveGFp_Repr::curve_mul_words
virtual void curve_mul_words(BigInt &z, const word x_words[], const size_t x_size, const BigInt &y, secure_vector< word > &ws) const =0
Botan::CurveGFp_Repr::get_p_words
virtual size_t get_p_words() const =0

virtual void Botan::CurveGFp_Repr::curve_mul_words | ( | BigInt & | z,
|  | const word | x_words[],
|  | const size_t | x_size,
|  | const BigInt & | y,
|  | secure_vector< word > & | ws
| ) |  | const
| pure virtual

void Botan::CurveGFp_Repr::curve_sqr | ( | BigInt & | z,
|  | const BigInt & | x,
|  | secure_vector< word > & | ws
| ) |  | const
| inline

Definition at line 74 of file curve_gfp.h.

References BOTAN_DEBUG_ASSERT, Botan::BigInt::data(), Botan::BigInt::sig_words(), and Botan::BigInt::size().

76 {
77 BOTAN_DEBUG_ASSERT(x.sig_words() <= get_p_words());
78 curve_sqr_words(z, x.data(), x.size(), ws);
79 }
Botan::CurveGFp_Repr::curve_sqr_words
virtual void curve_sqr_words(BigInt &z, const word x_words[], size_t x_size, secure_vector< word > &ws) const =0
BOTAN_DEBUG_ASSERT
#define BOTAN_DEBUG_ASSERT(expr)
Definition: assert.h:123
Botan::CurveGFp_Repr::get_p_words
virtual size_t get_p_words() const =0

virtual void Botan::CurveGFp_Repr::curve_sqr_words | ( | BigInt & | z,
|  | const word | x_words[],
|  | size_t | x_size,
|  | secure_vector< word > & | ws
| ) |  | const
| pure virtual

virtual void Botan::CurveGFp_Repr::from_curve_rep | ( | BigInt & | x,
|  | secure_vector< word > & | ws
| ) |  | const
| pure virtual

virtual const BigInt& Botan::CurveGFp_Repr::get_1_rep | ( |  | ) | const
| pure virtual

virtual const BigInt& Botan::CurveGFp_Repr::get_a | ( |  | ) | const
| pure virtual

virtual const BigInt& Botan::CurveGFp_Repr::get_a_rep | ( |  | ) | const
| pure virtual

virtual const BigInt& Botan::CurveGFp_Repr::get_b | ( |  | ) | const
| pure virtual

virtual const BigInt& Botan::CurveGFp_Repr::get_b_rep | ( |  | ) | const
| pure virtual

virtual const BigInt& Botan::CurveGFp_Repr::get_p | ( |  | ) | const
| pure virtual

virtual size_t Botan::CurveGFp_Repr::get_p_words | ( |  | ) | const
| pure virtual

virtual size_t Botan::CurveGFp_Repr::get_ws_size | ( |  | ) | const
| pure virtual

virtual BigInt Botan::CurveGFp_Repr::invert_element | ( | const BigInt & | x,
|  | secure_vector< word > & | ws
| ) |  | const
| pure virtual

virtual bool Botan::CurveGFp_Repr::is_one | ( | const BigInt & | x | ) | const
| pure virtual

virtual void Botan::CurveGFp_Repr::to_curve_rep | ( | BigInt & | x,
|  | secure_vector< word > & | ws
| ) |  | const
| pure virtual

The documentation for this class was generated from the following file:

- src/lib/pubkey/ec_group/curve_gfp.h